import { FocusMonitor } from '@angular/cdk/a11y';
import { BooleanInput } from '@angular/cdk/coercion';
import { ElementRef, OnInit, OnDestroy } from '@angular/core';
import { ControlValueAccessor, UntypedFormControl, NgControl } from '@angular/forms';
import { MatFormField, MatFormFieldControl } from '@angular/material/form-field';
import { Subject } from 'rxjs';
import { HttpService } from '../core/http.service';
import * as i0 from "@angular/core";
export declare class TechlifyTaggerTagSelectorComponent implements OnInit, ControlValueAccessor, MatFormFieldControl<any>, OnDestroy {
    private _focusMonitor;
    private _elementRef;
    private httpService;
    _formField: MatFormField;
    ngControl: NgControl;
    /**Pass the Categories to filter for a model */
    categories: string[];
    multiple: boolean;
    enableSearch: boolean;
    tagSelectorCtrl: UntypedFormControl;
    showAllTags: boolean;
    useSelectButtonStyle: boolean;
    tags: any[];
    static nextId: number;
    stateChanges: Subject<void>;
    focused: boolean;
    controlType: string;
    id: string;
    onChange: (_: any) => void;
    onTouched: () => void;
    get apiUrl(): string;
    get empty(): boolean;
    get shouldLabelFloat(): boolean;
    get required(): boolean;
    set required(value: boolean);
    private _required;
    get disabled(): boolean;
    set disabled(value: boolean);
    private _disabled;
    private _value;
    get value(): any;
    set value(val: any);
    get errorState(): boolean;
    get placeholder(): string;
    set placeholder(value: string);
    private _placeholder;
    ngOnInit(): void;
    selectionChange(value: any): void;
    constructor(_focusMonitor: FocusMonitor, _elementRef: ElementRef<HTMLElement>, httpService: HttpService, _formField: MatFormField, ngControl: NgControl);
    setDescribedByIds(ids: string[]): void;
    onContainerClick(): void;
    writeValue(val: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    _handleInput(): void;
    static ngAcceptInputType_disabled: BooleanInput;
    static ngAcceptInputType_required: BooleanInput;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TechlifyTaggerTagSelectorComponent, [null, null, null, { optional: true; }, { optional: true; self: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TechlifyTaggerTagSelectorComponent, "app-techlify-tagger-tag-selector", never, { "categories": { "alias": "categories"; "required": false; }; "multiple": { "alias": "multiple"; "required": false; }; "enableSearch": { "alias": "enableSearch"; "required": false; }; "showAllTags": { "alias": "showAllTags"; "required": false; }; "useSelectButtonStyle": { "alias": "useSelectButtonStyle"; "required": false; }; "required": { "alias": "required"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "value": { "alias": "value"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; }, {}, never, never, false, never>;
}
